package Allegory.PD0;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class Dog extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "Dog"; }

    public <TABLE> TABLE applyDog(Function<Dog,TABLE> f) { return f.apply(this); }

    public String name;
    public String zipcode;
    public String state;
    public String breed;
    public Person owner;
    protected String _owner;  // needed by database loader
    public Person favored;
    protected String _favored;  // needed by database loader

    public Dog(String id, String name, String zipcode, String state, String breed, Person owner, Person favored) {
       this.id = id;
       this.name = name;
       this.zipcode = zipcode;
       this.state = state;
       this.breed = breed;
       this.owner = owner;
       this.favored = favored;
    }

    // constructors used in database loading
    protected Dog() {}

    public Dog(String id, String name, String zipcode, String state, String breed) {
       this.id = id;
       this.name = name;
       this.zipcode = zipcode;
       this.state = state;
       this.breed = breed;
       this.owner = null;
       this.favored = null;
    }

    private Dog initFields(Tuple t) {
       id = t.get("id");
       name = t.get("name");
       zipcode = t.get("zipcode");
       state = t.get("state");
       breed = t.get("breed");
       _owner = t.get("owner");
       _favored = t.get("favored");
       return this;
    }

    public static Dog make(Tuple t) {
       return new Dog().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
       if(!_owner.equals("null"))
           owner = db.Person.getTuple(_owner,er);
       if(!_favored.equals("null"))
           favored = db.Person.getTuple(_favored,er);
    }
    // end of methods used for loading a database

    static final String fmt = "Dog(%s,%s,%s,%s,%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,name,zipcode,state,breed,__(owner),__(favored));
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,name,zipcode,state,breed,__(owner),__(favored));
    }

    public PersonTable owner() {
       return new PersonTable(db,this.owner);
    }  // diamondleft

    public PersonTable favored() {
       return new PersonTable(db,this.favored);
    }  // diamondleft

    public Person link2owner() {
       return this.owner;
    }  // diamondleft

}
