package Allegory.PD1;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.PD1.Lang.*;

public class DogTable extends TaBle<Database,Dog,DogTable> {
    @Override
    public String TupleTypeName() { return "Dog"; }

    public <TABLE> TABLE applyDog(Function<DogTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public DogTable(Database db) {
        this(db,null);
    }

    public DogTable(Database db, Dog t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static DogTable BaseRelation(Database db) {
        DogTable tab = new DogTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<Dog> tuples() {
        return tuples;
    }

    @Override
    public DogTable New() { return new DogTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       Dog r = new Dog(t.get("id"),t.get("name"),t.get("zipcode"),t.get("state"),t.get("breed"),t.getBool("preferred"));
       r._owner = t.get("owner");
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(Dog t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(Dog t) {
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(Dog,[id,name,zipcode,state,breed,preferred:boolean,owner:Person]).");
    }

    @Override
    public String pformat() { return Dog.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0, f3=0, f4=0, f5=0, f6=0;
       for (Dog a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.name).length()+2);
          f2 = Math.max(f2,(""+a.zipcode).length()+2);
          f3 = Math.max(f3,(""+a.state).length()+2);
          f4 = Math.max(f4,(""+a.breed).length()+2);
          f5 = Math.max(f5,(""+a.preferred).length()+2);
          f6 = Math.max(f6,a.owner.id.length());
       }
       return String.format("Dog(!%ds,!%ds,!%ds,!%ds,!%ds,!%db,!%ds).\n",f0,f1,f2,f3,f4,f5,f6).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable name() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.name)));
       return st;
    }

    public STRINGTable zipcode() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.zipcode)));
       return st;
    }

    public STRINGTable state() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.state)));
       return st;
    }

    public STRINGTable breed() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.breed)));
       return st;
    }

    public BOOLTable preferred() {
       BOOLTable st = new BOOLTable(db);
       tuples.forEach(t -> st.add(new BOOL(t.preferred)));
       return st;
    }

    public PersonTable owner() {
       PersonTable result = new PersonTable(db);
       for (Dog w : tuples()) {
          if (!result.contains(w.owner))
              result.add(w.owner);
       }
       return result; // diamondLeft
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
