package Allegory.PD1;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.PD1.Lang.*;

public class PersonTable extends TaBle<Database,Person,PersonTable> {
    @Override
    public String TupleTypeName() { return "Person"; }

    public <TABLE> TABLE applyPerson(Function<PersonTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public PersonTable(Database db) {
        this(db,null);
    }

    public PersonTable(Database db, Person t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static PersonTable BaseRelation(Database db) {
        PersonTable tab = new PersonTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<Person> tuples() {
        return tuples;
    }

    @Override
    public PersonTable New() { return new PersonTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       Person r = new Person(t.get("id"),t.get("name"),t.get("zipcode"),t.get("state"),t.get("occupation"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(Person t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(Person t) {
       t.owns().delete(); //b1
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(Person,[id,name,zipcode,state,occupation]).");
    }

    @Override
    public String pformat() { return Person.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0, f3=0, f4=0;
       for (Person a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.name).length()+2);
          f2 = Math.max(f2,(""+a.zipcode).length()+2);
          f3 = Math.max(f3,(""+a.state).length()+2);
          f4 = Math.max(f4,(""+a.occupation).length()+2);
       }
       return String.format("Person(!%ds,!%ds,!%ds,!%ds,!%ds).\n",f0,f1,f2,f3,f4).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable name() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.name)));
       return st;
    }

    public STRINGTable zipcode() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.zipcode)));
       return st;
    }

    public STRINGTable state() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.state)));
       return st;
    }

    public STRINGTable occupation() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.occupation)));
       return st;
    }

    public DogTable owns() {
       LinkedList<Person> tups = tuples();
       DogTable result = new DogTable(db);
       for(Dog a : db.Dog.tuples()) {
          if(tups.contains(a.owner) && !result.contains(a)) {
             result.add(a);
          }
       }
       return result; // diamondRight
   }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
