package Allegory.PD2;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class Entity extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "Entity"; }

    public <TABLE> TABLE applyEntity(Function<Entity,TABLE> f) { return f.apply(this); }

    public String name;
    public String zipcode;
    public String state;

    public Entity(String id, String name, String zipcode, String state) {
       this.id = id;
       this.name = name;
       this.zipcode = zipcode;
       this.state = state;
    }

    // constructors used in database loading
    protected Entity() {}

    private Entity initFields(Tuple t) {
       id = t.get("id");
       name = t.get("name");
       zipcode = t.get("zipcode");
       state = t.get("state");
       return this;
    }

    public static Entity make(Tuple t) {
       return new Entity().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
    }
    // end of methods used for loading a database

    static final String fmt = "Entity(%s,%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,name,zipcode,state);
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,name,zipcode,state);
    }

}
