package Allegory.PD2;

import Meta4Framework.*;
import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.LinkedList;

public class Lang {

/**************  STRING ******************/

    public static class STRING extends PrimTuPle<Database, String> {
       @Override
       public String TupleTypeName() { return "STRING"; };
       public STRING(String value) { this.value = value; this.id = value; }
       public static int compareTo(String x, String y) { return x.compareTo(y); }
       public static int compareTo(STRING x, STRING y) { return x.value.compareTo(y.value); }
       @Override
       public void finishTuple(Database db, ErrorReport er) {}
       @Override
       public String toString(String fmt) { return String.format(fmt, value); }
    }

    public static class STRINGTable extends TaBle<Database, STRING, STRINGTable> {
       @Override
       public String TupleTypeName() { return "STRING"; };
       public STRINGTable(Database db) { this.db = db; initTupleList(null); }
       public STRINGTable(Database db, STRING t) { this.db = db; initTupleList(t); }
       public boolean contains(String x) {
           for (STRING s : tuples()) 
               if (s.value.equals(x))
                   return true;
           return false;
       }
       @Override
       public STRINGTable duplicates() {
           LinkedList<String> unique = new LinkedList<>();
           STRINGTable dups = New();
           for (STRING t : tuples()) {
               if (!unique.contains(t.value)) {
                   unique.add(t.value);
               } else if (!dups.contains(t.value)){
                   dups.add(t);
               }
           }
           return dups;
       }
       @Override
       public boolean deleteFromSubTables(STRING t) { return false; }
       @Override
       public void makeAndAdd(Tuple t) { this.add(new STRING(t.getId())); }
       @Override
       public STRINGTable New() { return new STRINGTable(db); }
       @Override
       public LinkedList<STRING> tuples() { return tuples; }
       @Override
       public void mastHead(PrintStream out) {out.format("table(STRINGTable,[value]).\n");}
       @Override
       public void cascadingDeleteLocal(STRING t) {}
       @Override
       public String pformat() { return "%s\n"; }
       @Override
       public String ppformat(boolean local) {
          int i=0;
          for (STRING a : local?tuples:tuples())
          { i = Math.max(i,a.value.length()); }
          return "%"+i+"s\n";
       }
    }


/**************  INT ******************/

    public static class INT extends PrimTuPle<Database, Integer> {
       @Override
       public String TupleTypeName() { return "INT"; };
       public INT(Integer value) { this.value = value; this.id = value+""; }
       public static int compareTo(int x, int y) { return x > y?1: (x==y)? 0 : -1; }
       public static int compareTo(INT x, INT y) { return compareTo(x.value,y.value); }
       @Override
       public void finishTuple(Database db, ErrorReport er) {}
       @Override
       public String toString(String fmt) { return String.format(fmt, value); }
    }

    public static class INTTable extends TaBle<Database, INT, INTTable> {
       @Override
       public String TupleTypeName() { return "INT"; };
       public INTTable(Database db) { this.db = db; initTupleList(null); }
       public INTTable(Database db, INT t) { this.db = db; initTupleList(t); }
       public boolean contains(Integer x) {
           for (INT s : tuples()) 
               if (s.value.equals(x))
                   return true;
           return false;
       }
       @Override
       public INTTable duplicates() {
           LinkedList<Integer> unique = new LinkedList<>();
           INTTable dups = New();
           for (INT t : tuples()) {
               if (!unique.contains(t.value)) {
                   unique.add(t.value);
               } else if (!dups.contains(t.value)){
                   dups.add(t);
               }
           }
           return dups;
       }
       @Override
       public boolean deleteFromSubTables(INT t) { return false; }
       @Override
       public void makeAndAdd(Tuple t) { this.add(new INT(Integer.parseInt(t.getId()))); }
       @Override
       public INTTable New() { return new INTTable(db); }
       @Override
       public LinkedList<INT> tuples() { return tuples; }
       @Override
       public void mastHead(PrintStream out) {out.format("table(INTTable,[value]).\n");}
       @Override
       public void cascadingDeleteLocal(INT t) {}
       @Override
       public String pformat() { return "%d\n"; }
       @Override
       public String ppformat(boolean local) {
          int i=0;
          for (INT a : local?tuples:tuples())
          { i = Math.max(i,(""+a.value).length()); }
          return "%"+i+"d\n";
       }
    }


/**************  FLOAT ******************/

    public static class FLOAT extends PrimTuPle<Database, Float> {
       @Override
       public String TupleTypeName() { return "FLOAT"; };
       public FLOAT(Float value) { this.value = value; this.id = value+""; }
       public static int compareTo(float x, float y) { return x > y?1: (x==y)? 0 : -1; }
       public static int compareTo(FLOAT x, FLOAT y) { return compareTo(x.value,y.value); }
       @Override
       public void finishTuple(Database db, ErrorReport er) {}
       @Override
       public String toString(String fmt) { return String.format(fmt, value); }
    }

    public static class FLOATTable extends TaBle<Database, FLOAT, FLOATTable> {
       @Override
       public String TupleTypeName() { return "FLOAT"; };
       public FLOATTable(Database db) { this.db = db; initTupleList(null); }
       public FLOATTable(Database db, FLOAT t) { this.db = db; initTupleList(t); }
       public boolean contains(Float x) {
           for (FLOAT s : tuples()) 
               if (s.value.equals(x))
                   return true;
           return false;
       }
       @Override
       public FLOATTable duplicates() {
           LinkedList<Float> unique = new LinkedList<>();
           FLOATTable dups = New();
           for (FLOAT t : tuples()) {
               if (!unique.contains(t.value)) {
                   unique.add(t.value);
               } else if (!dups.contains(t.value)){
                   dups.add(t);
               }
           }
           return dups;
       }
       @Override
       public boolean deleteFromSubTables(FLOAT t) { return false; }
       @Override
       public void makeAndAdd(Tuple t) { this.add(new FLOAT(Float.parseFloat(t.getId()))); }
       @Override
       public FLOATTable New() { return new FLOATTable(db); }
       @Override
       public LinkedList<FLOAT> tuples() { return tuples; }
       @Override
       public void mastHead(PrintStream out) {out.format("table(FLOATTable,[value]).\n");}
       @Override
       public void cascadingDeleteLocal(FLOAT t) {}
       @Override
       public String pformat() { return "%f\n"; }
       @Override
       public String ppformat(boolean local) {
          int i=0;
          for (FLOAT a : local?tuples:tuples())
          { i = Math.max(i,(""+a.value).length()); }
          return "%"+i+"f\n";
       }
    }


/**************  DOUBLE ******************/

    public static class DOUBLE extends PrimTuPle<Database, Double> {
       @Override
       public String TupleTypeName() { return "DOUBLE"; };
       public DOUBLE(Double value) { this.value = value; this.id = value+""; }
       public static int compareTo(double x, double y) { return x > y?1: (x==y)? 0 : -1; }
       public static int compareTo(DOUBLE x, DOUBLE y) { return compareTo(x.value,y.value); }
       @Override
       public void finishTuple(Database db, ErrorReport er) {}
       @Override
       public String toString(String fmt) { return String.format(fmt, value); }
    }

    public static class DOUBLETable extends TaBle<Database, DOUBLE, DOUBLETable> {
       @Override
       public String TupleTypeName() { return "DOUBLE"; };
       public DOUBLETable(Database db) { this.db = db; initTupleList(null); }
       public DOUBLETable(Database db, DOUBLE t) { this.db = db; initTupleList(t); }
       public boolean contains(Double x) {
           for (DOUBLE s : tuples()) 
               if (s.value.equals(x))
                   return true;
           return false;
       }
       @Override
       public DOUBLETable duplicates() {
           LinkedList<Double> unique = new LinkedList<>();
           DOUBLETable dups = New();
           for (DOUBLE t : tuples()) {
               if (!unique.contains(t.value)) {
                   unique.add(t.value);
               } else if (!dups.contains(t.value)){
                   dups.add(t);
               }
           }
           return dups;
       }
       @Override
       public boolean deleteFromSubTables(DOUBLE t) { return false; }
       @Override
       public void makeAndAdd(Tuple t) { this.add(new DOUBLE(Double.parseDouble(t.getId()))); }
       @Override
       public DOUBLETable New() { return new DOUBLETable(db); }
       @Override
       public LinkedList<DOUBLE> tuples() { return tuples; }
       @Override
       public void mastHead(PrintStream out) {out.format("table(DOUBLETable,[value]).\n");}
       @Override
       public void cascadingDeleteLocal(DOUBLE t) {}
       @Override
       public String pformat() { return "%f\n"; }
       @Override
       public String ppformat(boolean local) {
          int i=0;
          for (DOUBLE a : local?tuples:tuples())
          { i = Math.max(i,(""+a.value).length()); }
          return "%"+i+"f\n";
       }
    }


/**************  BOOL ******************/

    public static class BOOL extends PrimTuPle<Database, Boolean> {
       @Override
       public String TupleTypeName() { return "BOOL"; };
       public BOOL(Boolean value) { this.value = value; this.id = value+""; }
       public static int compareTo(boolean x, boolean y) { return x&&!y?1: (x==y)? 0 : -1; }
       public static int compareTo(BOOL x, BOOL y) { return compareTo(x.value,y.value); }
       @Override
       public void finishTuple(Database db, ErrorReport er) {}
       @Override
       public String toString(String fmt) { return String.format(fmt, value); }
    }

    public static class BOOLTable extends TaBle<Database, BOOL, BOOLTable> {
       @Override
       public String TupleTypeName() { return "BOOL"; };
       public BOOLTable(Database db) { this.db = db; initTupleList(null); }
       public BOOLTable(Database db, BOOL t) { this.db = db; initTupleList(t); }
       public boolean contains(Boolean x) {
           for (BOOL s : tuples()) 
               if (s.value.equals(x))
                   return true;
           return false;
       }
       @Override
       public BOOLTable duplicates() {
           LinkedList<Boolean> unique = new LinkedList<>();
           BOOLTable dups = New();
           for (BOOL t : tuples()) {
               if (!unique.contains(t.value)) {
                   unique.add(t.value);
               } else if (!dups.contains(t.value)){
                   dups.add(t);
               }
           }
           return dups;
       }
       @Override
       public boolean deleteFromSubTables(BOOL t) { return false; }
       @Override
       public void makeAndAdd(Tuple t) { this.add(new BOOL(Boolean.parseBoolean(t.getId()))); }
       @Override
       public BOOLTable New() { return new BOOLTable(db); }
       @Override
       public LinkedList<BOOL> tuples() { return tuples; }
       @Override
       public void mastHead(PrintStream out) {out.format("table(BOOLTable,[value]).\n");}
       @Override
       public void cascadingDeleteLocal(BOOL t) {}
       @Override
       public String pformat() { return "%b\n"; }
       @Override
       public String ppformat(boolean local) {
          int i=0;
          for (BOOL a : local?tuples:tuples())
          { i = Math.max(i,(""+a.value).length()); }
          return "%"+i+"b\n";
       }
    }

/**************  DTuple ******************/

    public static class DTuple  {
       DTable belongsTo = null;
       LinkedList<String> values = new LinkedList<>();
       public DTuple(String... vals) { values.addAll(Arrays.asList(vals)); }
       public String get(int i) { return values.get(i);}
       public void put(int i, String v) { values.set(i, v);}
       public int size() { return values.size();}
       @Override
       public String toString() {  String result = (belongsTo==null? "": belongsTo.name)+ "("; String comma = "";
          for (String v:values) { result += comma + v; comma = ","; }
          return result+").";
       }
    }

    public static class DTable  {
       String name;
       public LinkedList<DTuple> tuples = new LinkedList<>();
       LinkedList<String> colnames = new LinkedList<>();
       public DTable(String name, String... cols) { this.name=name; colnames.addAll(Arrays.asList(cols)); }
       public void add(DTuple t) {
           if (t.size()!=colnames.size()) {
               String msg = "tuple size ("+t.size()+") does not match table size ("+colnames.size()+")";
               throw new RuntimeException(msg);
           }
           tuples.add(t);
           t.belongsTo=this;
       }
       public void add(String... vals) {
           DTuple d = new DTuple(vals);
           add(d);
       }
       @Override
       public String toString() { 
           String result = "table("+name+",[";  String comma = "";
           for (String c: colnames) { result += comma + c; comma = ","; } result +="]).";
           for (DTuple d : tuples) {  result += "\n"+d; }
           return result +"\n";
       }
       public void print(PrintStream out) { out.print(this); }
       public void print() { System.out.print(this); }
    }

}
