package Allegory.PD2;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;

public class Person extends Entity {
    @Override
    public String TupleTypeName() { return "Person"; }

    public <TABLE> TABLE applyPerson(Function<Person,TABLE> f) { return f.apply(this); }

    public String occupation;

    public Person(String id, String name, String zipcode, String state, String occupation) {
       this.id = id;
       this.name = name;
       this.zipcode = zipcode;
       this.state = state;
       this.occupation = occupation;
    }

    // constructors used in database loading
    protected Person() {}

    private Person initFields(Tuple t) {
       id = t.get("id");
       name = t.get("name");
       zipcode = t.get("zipcode");
       state = t.get("state");
       occupation = t.get("occupation");
       return this;
    }

    public static Person make(Tuple t) {
       return new Person().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
    }
    // end of methods used for loading a database

    static final String fmt = "Person(%s,%s,%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,name,zipcode,state,occupation);
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,name,zipcode,state,occupation);
    }

    public DogTable owns() {
       DogTable result = new DogTable(db);
       for(Dog a : db.Dog.tuples()) {
          if(a.owner==this) {
             result.add(a);
          }
       }
       return result; ///diamondRight
   }

}
