package Allegory.PD3;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class Address extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "Address"; }

    public <TABLE> TABLE applyAddress(Function<Address,TABLE> f) { return f.apply(this); }

    public String zipcode;
    public String state;

    public Address(String id, String zipcode, String state) {
       this.id = id;
       this.zipcode = zipcode;
       this.state = state;
    }

    // constructors used in database loading
    protected Address() {}

    private Address initFields(Tuple t) {
       id = t.get("id");
       zipcode = t.get("zipcode");
       state = t.get("state");
       return this;
    }

    public static Address make(Tuple t) {
       return new Address().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
    }
    // end of methods used for loading a database

    static final String fmt = "Address(%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,zipcode,state);
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,zipcode,state);
    }

    public EntityTable livesAt() {
       EntityTable result = new EntityTable(db);
       for(Entity a : db.Entity.tuples()) {
          if(a.addr==this) {
             result.add(a);
          }
       }
       return result; ///diamondRight
   }

}
