package Allegory.PD3;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.PD3.Lang.*;

public class AddressTable extends TaBle<Database,Address,AddressTable> {
    @Override
    public String TupleTypeName() { return "Address"; }

    public <TABLE> TABLE applyAddress(Function<AddressTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public AddressTable(Database db) {
        this(db,null);
    }

    public AddressTable(Database db, Address t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static AddressTable BaseRelation(Database db) {
        AddressTable tab = new AddressTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<Address> tuples() {
        return tuples;
    }

    @Override
    public AddressTable New() { return new AddressTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       Address r = new Address(t.get("id"),t.get("zipcode"),t.get("state"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(Address t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(Address t) {
       t.livesAt().delete(); //b1
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(Address,[id,zipcode,state]).");
    }

    @Override
    public String pformat() { return Address.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0;
       for (Address a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.zipcode).length()+2);
          f2 = Math.max(f2,(""+a.state).length()+2);
       }
       return String.format("Address(!%ds,!%ds,!%ds).\n",f0,f1,f2).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable zipcode() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.zipcode)));
       return st;
    }

    public STRINGTable state() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.state)));
       return st;
    }

    public EntityTable livesAt() {
       LinkedList<Address> tups = tuples();
       EntityTable result = new EntityTable(db);
       for(Entity a : db.Entity.tuples()) {
          if(tups.contains(a.addr) && !result.contains(a)) {
             result.add(a);
          }
       }
       return result; // diamondRight
   }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
