package Allegory.PD3;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class Entity extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "Entity"; }

    public <TABLE> TABLE applyEntity(Function<Entity,TABLE> f) { return f.apply(this); }

    public String name;
    public Address addr;
    protected String _addr;  // needed by database loader

    public Entity(String id, String name, Address addr) {
       this.id = id;
       this.name = name;
       this.addr = addr;
    }

    // constructors used in database loading
    protected Entity() {}

    public Entity(String id, String name) {
       this.id = id;
       this.name = name;
       this.addr = null;
    }

    private Entity initFields(Tuple t) {
       id = t.get("id");
       name = t.get("name");
       _addr = t.get("addr");
       return this;
    }

    public static Entity make(Tuple t) {
       return new Entity().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
       if(!_addr.equals("null"))
           addr = db.Address.getTuple(_addr,er);
    }
    // end of methods used for loading a database

    static final String fmt = "Entity(%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,name,__(addr));
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,name,__(addr));
    }

    public AddressTable addr() {
       return new AddressTable(db,this.addr);
    }  // diamondleft

    public Address link2addr() {
       return this.addr;
    }  // diamondleft

}
